#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 8;

# $Id: IdlArgInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $interface = $repository -> find_by_name("Foo", "Iface1");
my $method = $interface -> find_method("method1");

my $arg = ($method -> get_args())[0];
isa_ok($arg, "Glib::Object::Introspection::ArgInfo");

is($arg -> get_direction(), "in");
ok(!$arg -> is_dipper());
ok(!$arg -> is_return_value());
ok(!$arg -> is_optional());
ok(!$arg -> may_be_null());
is($arg -> get_ownership_transfer(), "nothing");
isa_ok($arg -> get_type(), "Glib::Object::Introspection::TypeInfo");
