#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 5;

# $Id: IdlBaseInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $info = $repository -> find_by_name("Foo", "Iface1");
is($info -> get_name(), "Iface1");
is($info -> get_namespace(), "Foo");
ok(!$info -> is_deprecated());
is($info -> get_annotation("Foo.Iface1"), undef);
isa_ok($info -> get_container(), "Glib::Object::Introspection::InterfaceInfo");
