#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 6;

# $Id: IdlCallableInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $interface = $repository -> find_by_name("Foo", "Iface1");

my $callable = $interface -> find_method("method1");
isa_ok($callable, "Glib::Object::Introspection::CallableInfo");

isa_ok($callable -> get_return_type(), "Glib::Object::Introspection::TypeInfo");
ok($callable -> get_caller_owns());
ok($callable -> may_return_null());

my @args = $callable -> get_args();
TODO: {
  local $TODO = "FIXME: get_n_args seems to be broken";
  is(@args, 1);
}
isa_ok($args[0], "Glib::Object::Introspection::ArgInfo");
