#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 5;

# $Id: IdlFunctionInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $function = $repository -> find_by_name("Foo", "test1");
isa_ok($function, "Glib::Object::Introspection::FunctionInfo");
is($function -> get_symbol(), "test1");
is($function -> get_flags(), []);

SKIP: {
  skip "FIXME: get_property() and get_vfunc() are broken", 2;
  is($function -> get_property(), undef);
  is($function -> get_vfunc(), undef);
}
