#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 14;

# $Id: IdlInterfaceInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $interface = $repository -> find_by_name("Foo", "Iface1");
isa_ok($interface, "Glib::Object::Introspection::InterfaceInfo");

my @prerequisites = $interface -> get_prerequisites();
is(@prerequisites, 1);
isa_ok($prerequisites[0], "Glib::Object::Introspection::InterfaceInfo");

my @properties = $interface -> get_properties();
is(@properties, 1);
isa_ok($properties[0], "Glib::Object::Introspection::PropertyInfo");

my @methods = $interface -> get_methods();
is(@methods, 1);
isa_ok($methods[0], "Glib::Object::Introspection::FunctionInfo");
isa_ok($interface -> find_method("method1"), "Glib::Object::Introspection::FunctionInfo");

my @signals = $interface -> get_signals();
is(@signals, 2);
isa_ok($signals[0], "Glib::Object::Introspection::SignalInfo");

my @vfuncs = $interface -> get_vfuncs();
is(@vfuncs, 1);
isa_ok($vfuncs[0], "Glib::Object::Introspection::VFuncInfo");

my @constants = $interface -> get_constants();
is(@constants, 1);
isa_ok($constants[0], "Glib::Object::Introspection::ConstantInfo");
