#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 17;

# $Id: IdlObjectInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $object = $repository -> find_by_name("Foo", "Object1");
isa_ok($object, "Glib::Object::Introspection::ObjectInfo");
isa_ok($object -> get_parent(), "Glib::Object::Introspection::ObjectInfo");

my @interfaces = $object -> get_interfaces();
is(@interfaces, 1);
isa_ok($interfaces[0], "Glib::Object::Introspection::InterfaceInfo");

my @fields = $object -> get_fields();
is(@fields, 1);
isa_ok($fields[0], "Glib::Object::Introspection::FieldInfo");

my @properties = $object -> get_properties();
is(@properties, 1);
isa_ok($properties[0], "Glib::Object::Introspection::PropertyInfo");

my @methods = $object -> get_methods();
is(@methods, 1);
isa_ok($methods[0], "Glib::Object::Introspection::FunctionInfo");
isa_ok($object -> find_method("method1"), "Glib::Object::Introspection::FunctionInfo");

my @signals = $object -> get_signals();
is(@signals, 2);
isa_ok($signals[0], "Glib::Object::Introspection::SignalInfo");

my @vfuncs = $object -> get_vfuncs();
is(@vfuncs, 1);
isa_ok($vfuncs[0], "Glib::Object::Introspection::VFuncInfo");

my @constants = $object -> get_constants();
is(@constants, 1);
isa_ok($constants[0], "Glib::Object::Introspection::ConstantInfo");
