#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 6;

# $Id: IdlRepository.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
isa_ok($repository, "Glib::Object::Introspection::Repository");
isa_ok($repository, "Glib::Object");

my $metadata = join "", `cat t/test.raw`;
$repository -> register($metadata);

my $info = $repository -> find_by_name("Foo", "Enum1");
isa_ok($info, "Glib::Object::Introspection::BaseInfo");

is_deeply([$repository -> get_namespaces()], ["Foo"]);

my @infos = $repository -> get_infos("Foo");
is(@infos, 9);
isa_ok($infos[0], "Glib::Object::Introspection::BaseInfo");

$repository -> unregister($metadata);
