#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 3;

# $Id: IdlSignalInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $object = $repository -> find_by_name("Foo", "Object1");
my $signal = $object -> get_signals();

is($signal -> get_flags(), [qw(run-first no-recurse detailed action no-hooks)]);
is($signal -> get_class_closure(), undef);
ok(!$signal -> true_stops_emit());
