#!/usr/bin/perl
use strict;
use warnings;
use Glib::Object::Introspection;
use Test::More tests => 7;

# $Id: IdlTypeInfo.t,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $

my $repository = Glib::Object::Introspection::Repository -> get_default();
$repository -> register(join "", `cat t/test.raw`);

my $function = $repository -> find_by_name("Foo", "test1");
my $arg = ($function -> get_args())[0];
my $type = $arg -> get_type();

ok($type -> is_pointer());
is($type -> get_tag(), "array");
isa_ok($type -> get_param_type(0), "Glib::Object::Introspection::TypeInfo");
is($type -> get_array_length(), 1);
ok($type -> is_zero_terminated());

is($type -> get_interface(), undef);
is($type -> get_error_domains(), undef);
