/*
 * Copyright (C) 2005 by the gtk2-perl team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: IdlStructInfo.xs,v 1.1.1.1 2005/08/21 14:39:45 torsten Exp $
 */

#include "gobject-introspection-perl.h"

SV *
newSVGIStructInfo (GIStructInfo *info)
{
        SV *sv = newSV (0);

        return sv_setref_pv (sv, "Glib::Object::Introspection::StructInfo", info);
}

GIStructInfo *
SvGIStructInfo (SV *info)
{
        return INT2PTR (GIStructInfo *, SvIV (SvRV (info)));

}

MODULE = Glib::Object::Introspection::StructInfo	PACKAGE = Glib::Object::Introspection::StructInfo	PREFIX = g_struct_info_

# gint g_struct_info_get_n_fields (GIStructInfo *info);
# GIFieldInfo * g_struct_info_get_field (GIStructInfo *info, gint n);
void
g_struct_info_get_fields (info)
	GIStructInfo *info
    PREINIT:
	gint number, i;
    PPCODE:
	number = g_struct_info_get_n_fields (info);
	EXTEND (sp, number);
	for (i = 0; i < number; i++)
		PUSHs (sv_2mortal (newSVGIFieldInfo (
		  g_struct_info_get_field (info, i))));

# gint g_struct_info_get_n_methods (GIStructInfo *info);
# GIFunctionInfo * g_struct_info_get_method (GIStructInfo *info, gint n);
void
g_struct_info_get_methods (info)
	GIStructInfo *info
    PREINIT:
	gint number, i;
    PPCODE:
	number = g_struct_info_get_n_methods (info);
	EXTEND (sp, number);
	for (i = 0; i < number; i++)
		PUSHs (sv_2mortal (newSVGIFunctionInfo (
		  g_struct_info_get_method (info, i))));

GIFunctionInfo * g_struct_info_find_method (GIStructInfo *info, const gchar *name);
